#import "GifWell.h"


@implementation GifWell


- (BOOL)acceptsFirstMouse:(NSEvent *)theEvent {return YES;}
- (BOOL)shouldDelayWindowOrderingForEvent:(NSEvent *)theEvent
{
	return YES; 	// see NSView.rtfd for full explanation
}

- (unsigned int)draggingSourceOperationMaskForLocal:(BOOL)flag
{
	if (flag) return NSDragOperationCopy;
#ifdef USING_DPS
        return NSDragOperationCopy|NSDragOperationGeneric/*|NSDragOperationLink*/;
#else
        return NSDragOperationEvery;
#endif
}

- (BOOL)copyDataTo:pboard
{
	if (path != nil) {
		[pboard declareTypes:[NSArray arrayWithObject:NSFilenamesPboardType] owner:self];
		[pboard setPropertyList:[NSArray arrayWithObject:path] forType:NSFilenamesPboardType];
		return YES;
	} else return NO;

}


- (void)setFile:(NSString *)aPath
{
	[path autorelease];
	[image release];
	if (!aPath) {
		path = image = nil;
	} else {
		path = [aPath copy];
		image = [[[NSWorkspace sharedWorkspace] iconForFile:aPath]retain];
	}
	[self display];
}


- (void)drawRect:(NSRect)rects
{
#ifdef USING_DPS
	NSDrawGrayBezel([self bounds] , [self bounds]);
#else
    static NSColor *wellColor = nil;
    NSRect r = [self bounds];

    if (!wellColor) {
        NSImage *im = nil; // BROKEN in DP4 [[NSImage imageNamed:@"wellColor.tiff"]retain];
        if (im)
            wellColor = [[NSColor colorWithPatternImage:im]retain];
        else wellColor = [[NSColor windowBackgroundColor] retain];
    }
    NSDrawGrayBezel(r , r);
    [wellColor set];
    NSRectFill(NSInsetRect(r,2.0,2.0));
#endif
	if (image != nil) {
		NSPoint p;
		NSSize sz = [image size];
		p.x = ([self bounds].size.width - sz.width)/2.;
		p.y = ([self bounds].size.height - sz.height)/2.;
		[image compositeToPoint:p operation:NSCompositeSourceOver];
	}
}

- (void)revealInFinder:(id)sender {
	BOOL isDir;
	if ([[NSFileManager defaultManager] fileExistsAtPath:path isDirectory:&isDir]) {
            if (isDir)
            [[NSWorkspace sharedWorkspace] selectFile:nil inFileViewerRootedAtPath:path];
            else
            [[NSWorkspace sharedWorkspace] selectFile:path inFileViewerRootedAtPath:nil];
	}
}

- (void)mouseDown:(NSEvent *)e 
{
	NSPoint location;
	NSSize size;
	NSPasteboard *pb = [NSPasteboard pasteboardWithName:(NSString *) NSDragPboard];
         NSTimeInterval endTime, startTime = [e timestamp];

        if (image && [self copyDataTo:pb]) {
		size = [image size];
		location.x = ([self bounds].size.width - size.width)/2;
		location.y = ([self bounds].size.height - size.height)/2;

		[self dragImage:image at:location offset:NSZeroSize event:(NSEvent *)e pasteboard:pb source:self slideBack:YES];
	}
        endTime = [[[self window] currentEvent] timestamp];
        if (endTime - startTime < .40)
            [self performSelector:@selector(revealInFinder:) withObject:nil afterDelay:0.5];
}

@end
